<h1>CodeRunner</h1>
<div class="markdown"><p>You need to have something to capture the output. This is useful when you want to have examples or capture test output in the docs.</p>
<p>I think the simplest way to do this is to do the following👇</p>
<ul>
<li><p>Take a notebook. </p>
</li>
<li><p>Create a fake server, fake client etc.</p>
</li>
<li><p>Run the notebook cell by cell and update the notebook with the output.</p>
</li>
</ul>
<p>This is taken straight from Pluto&#39;s webserver code</p>
</div>
```
using PlutoTest
------
Output
------

```

## executecode

```
    notebook = Notebook([
        Cell("x = 1"),
        Cell("y = x"),
        Cell("f(x) = x + y"),
        Cell("f(4)"),
    
        Cell("""begin
            g(a) = x
            g(a,b) = y      
        end"""),
        Cell("g(6) + g(6,6)"),
    
        Cell("import Distributed"),
        Cell("Distributed.myid()"),
    ])
------
Output
------
Any["Notebook", Any[(:cells_dict, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Pluto.Cell}", :elements => Any[(("UUID(\"e29f8c70-5a60-11ec-1d98-6b0d3a1c0507\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-1d98-6b0d3a1c0507\")", MIME type text/plain)), (:code, ("\"f(4)\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "d574db94d901a292"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "d7d358acd9d30cff"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "32a48ddf8f757bd7"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "8a9b1fa53f62a04d"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "ba96c700bf4ac184"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "34b479eb216a9aa"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"e29f8c70-5a60-11ec-24f6-97c93ef6164d\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-24f6-97c93ef6164d\")", MIME type text/plain)), (:code, ("\"x = 1\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "d574db94d901a292"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "30b8db1a0b9e27b4"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "d8f3e44b5c143c74"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "124349144eb2f731"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "1d8ae06d53b7fa27"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "3bfbdf43a377e46b"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"e29f8c70-5a60-11ec-19d8-914389ca9ff1\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-19d8-914389ca9ff1\")", MIME type text/plain)), (:code, ("\"y = x\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "d574db94d901a292"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "ab3236b60090cf4a"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "848ceb7fb34639f2"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "6dd53d4885d6e504"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "13dff5c5d1207f20"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "42cf3454311e8c80"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"e29f8c70-5a60-11ec-0bb1-ebbe763dde2e\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-0bb1-ebbe763dde2e\")", MIME type text/plain)), (:code, ("\"Distributed.myid()\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "d574db94d901a292"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "c837c2d23a9bceea"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "59b3be89dd93b903"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "f446512512b8daff"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "24da8d2c6e16929b"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "7db20e7526e42b11"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"e29f8c70-5a60-11ec-2e8e-330a12d1c56f\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-2e8e-330a12d1c56f\")", MIME type text/plain)), (:code, ("\"begin\\n    g(a) = x\\n    g(a,b) = y      \\nend\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "d574db94d901a292"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "a38864c4713d27ab"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "e98e1404fd48773b"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "8b51361a40cebdbf"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "2f4846b4d0f50d3a"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "dd262e48e5cc7637"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"e29f8c70-5a60-11ec-2a1d-19bc9b238325\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-2a1d-19bc9b238325\")", MIME type text/plain)), (:code, ("\"g(6) + g(6,6)\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "d574db94d901a292"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "694f3d4bfccac7d3"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "4ea26637c771210f"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "285eb5577ae9b0c3"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "37afd75fbb2338cc"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "e866b00afc4d779f"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"e29f8c70-5a60-11ec-2337-2d3c936c9f83\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-2337-2d3c936c9f83\")", MIME type text/plain)), (:code, ("\"f(x) = x + y\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "d574db94d901a292"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "debfd44067ac0fc6"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "76adb52a1787d2af"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "3e08e74aa63e2945"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "11ef0c4f375bc02a"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "2ebe6c2588fcfa07"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"e29f8c70-5a60-11ec-127a-4580729df82c\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-127a-4580729df82c\")", MIME type text/plain)), (:code, ("\"import Distributed\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "d574db94d901a292"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "ddf54b35e616d989"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "925c6c104ee5227b"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "f22cb6898e85b560"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "b50af69407011a6b"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "d04e0d55cc1c2ae9"), MIME type application/vnd.pluto.tree+object))], :type => :Dict, :prefix_short => "Dict", :objectid => "6f5c153988e4698a"), MIME type application/vnd.pluto.tree+object)), (:cell_order, (Dict{Symbol, Any}(:prefix => "Base.UUID", :elements => Tuple{Int64, Any}[(1, ("UUID(\"e29f8c70-5a60-11ec-24f6-97c93ef6164d\")", MIME type text/plain)), (2, ("UUID(\"e29f8c70-5a60-11ec-19d8-914389ca9ff1\")", MIME type text/plain)), (3, ("UUID(\"e29f8c70-5a60-11ec-2337-2d3c936c9f83\")", MIME type text/plain)), (4, ("UUID(\"e29f8c70-5a60-11ec-1d98-6b0d3a1c0507\")", MIME type text/plain)), (5, ("UUID(\"e29f8c70-5a60-11ec-2e8e-330a12d1c56f\")", MIME type text/plain)), (6, ("UUID(\"e29f8c70-5a60-11ec-2a1d-19bc9b238325\")", MIME type text/plain)), (7, ("UUID(\"e29f8c70-5a60-11ec-127a-4580729df82c\")", MIME type text/plain)), (8, ("UUID(\"e29f8c70-5a60-11ec-0bb1-ebbe763dde2e\")", MIME type text/plain))], :type => :Array, :prefix_short => "", :objectid => "157043a5d5e29174"), MIME type application/vnd.pluto.tree+object)), (:path, ("\"C:\\\\Users\\\\family\\\\.julia\\\\pluto_notebooks\\\\Cute analysis.jl\"", MIME type text/plain)), (:notebook_id, ("UUID(\"e29f8c70-5a60-11ec-134e-09f21a771bdf\")", MIME type text/plain)), (:topology, (Dict{Symbol, Any}(:prefix => "Pluto.NotebookTopology", :elements => Any[(:nodes, (Dict{Symbol, Any}(:prefix => "Pluto.DefaultDict{Pluto.Cell, Pluto.ReactiveNode}", :elements => Any[], :type => :Dict, :prefix_short => "DefaultDict", :objectid => "e418ef6ea3528903"), MIME type application/vnd.pluto.tree+object)), (:codes, (Dict{Symbol, Any}(:prefix => "Pluto.DefaultDict{Pluto.Cell, Pluto.ExprAnalysisCache}", :elements => Any[], :type => :Dict, :prefix_short => "DefaultDict", :objectid => "f7847441ccb77d1a"), MIME type application/vnd.pluto.tree+object)), (:unresolved_cells, (Dict{Symbol, Any}(:prefix => "Dict{Pluto.Cell, Pluto.ExpressionExplorer.SymbolsState}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "ecf97e62841f2c62"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "NotebookTopology", :objectid => "ae5b6b5bcd159f31"), MIME type application/vnd.pluto.tree+object)), (:_cached_topological_order, ("nothing", MIME type text/plain)), (:pendingupdates, ("Channel{Any}(1024) (empty)", MIME type text/plain)), (:executetoken, (Dict{Symbol, Any}(:prefix => "Pluto.Token", :elements => Any[(:c, ("Channel{Nothing}(1) (1 item available)", MIME type text/plain))], :type => :struct, :prefix_short => "Token", :objectid => "f4b69849ad38f404"), MIME type application/vnd.pluto.tree+object)), (:compiler_options, ("nothing", MIME type text/plain)), (:nbpkg_ctx, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Context", :elements => Any[(:env, (Dict{Symbol, Any}(:prefix => "Pkg.Types.EnvCache", :elements => Any[(:env, ("\"C:\\\\Users\\\\family\\\\AppData\\\\Local\\\\Temp\\\\jl_eoJRD6\\\\Project.toml\"", MIME type text/plain)), (:project_file, ("\"C:\\\\Users\\\\family\\\\AppData\\\\Local\\\\Temp\\\\jl_eoJRD6\\\\Project.toml\"", MIME type text/plain)), (:manifest_file, ("\"C:\\\\Users\\\\family\\\\AppData\\\\Local\\\\Temp\\\\jl_eoJRD6\\\\Manifest.toml\"", MIME type text/plain)), (:pkg, ("nothing", MIME type text/plain)), (:project, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Project", :elements => Any[(:other, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "3ff4dc76a8ac6585"), MIME type application/vnd.pluto.tree+object)), (:name, ("nothing", MIME type text/plain)), (:uuid, ("nothing", MIME type text/plain)), (:version, ("nothing", MIME type text/plain)), (:manifest, ("nothing", MIME type text/plain)), (:deps, (Dict{Symbol, Any}(:prefix => "Dict{String, Base.UUID}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "a3b1062b7024c9a9"), MIME type application/vnd.pluto.tree+object)), (:extras, (Dict{Symbol, Any}(:prefix => "Dict{String, Base.UUID}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "f560f94a1385daa1"), MIME type application/vnd.pluto.tree+object)), (:targets, (Dict{Symbol, Any}(:prefix => "Dict{String, Vector{String}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "9a1af9cadcf9dca0"), MIME type application/vnd.pluto.tree+object)), (:compat, (Dict{Symbol, Any}(:prefix => "Dict{String, String}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "9dddd691647f93a9"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Project", :objectid => "d9397fa6dbfa477b"), MIME type application/vnd.pluto.tree+object)), (:manifest, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Manifest", :elements => Any[(:julia_version, ("nothing", MIME type text/plain)), (:manifest_format, ("v\"1.0.0\"", MIME type text/plain)), (:deps, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Pkg.Types.PackageEntry}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "eca116c8020608a1"), MIME type application/vnd.pluto.tree+object)), (:other, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "6000679be8c4ab57"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Manifest", :objectid => "6fb885df85d7af7a"), MIME type application/vnd.pluto.tree+object)), (:original_project, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Project", :elements => Any[(:other, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "ece3992465d8f29"), MIME type application/vnd.pluto.tree+object)), (:name, ("nothing", MIME type text/plain)), (:uuid, ("nothing", MIME type text/plain)), (:version, ("nothing", MIME type text/plain)), (:manifest, ("nothing", MIME type text/plain)), (:deps, (Dict{Symbol, Any}(:prefix => "Dict{String, Base.UUID}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "ae769dd585ae69f5"), MIME type application/vnd.pluto.tree+object)), (:extras, (Dict{Symbol, Any}(:prefix => "Dict{String, Base.UUID}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "75bbb7f514389f25"), MIME type application/vnd.pluto.tree+object)), (:targets, (Dict{Symbol, Any}(:prefix => "Dict{String, Vector{String}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "8f8f9d5247e06733"), MIME type application/vnd.pluto.tree+object)), (:compat, (Dict{Symbol, Any}(:prefix => "Dict{String, String}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "4bc4b793c04a9763"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Project", :objectid => "5cb52016e2f1082d"), MIME type application/vnd.pluto.tree+object)), (:original_manifest, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Manifest", :elements => Any[(:julia_version, ("nothing", MIME type text/plain)), (:manifest_format, ("v\"1.0.0\"", MIME type text/plain)), (:deps, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Pkg.Types.PackageEntry}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "1fd9d8fde874dc6c"), MIME type application/vnd.pluto.tree+object)), (:other, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "b321820f8f042a4d"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Manifest", :objectid => "9dfb688e625d7623"), MIME type application/vnd.pluto.tree+object)), (:uuids, (Dict{Symbol, Any}(:prefix => "Dict{String, Vector{Base.UUID}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "ca3c449bbd39ad59"), MIME type application/vnd.pluto.tree+object)), (:paths, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Vector{String}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "6974bc007baa9614"), MIME type application/vnd.pluto.tree+object)), (:names, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Vector{String}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "b9aac72a347097"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "EnvCache", :objectid => "4cb00fa942e6e932"), MIME type application/vnd.pluto.tree+object)), (:io, ("Base.PipeEndpoint(Base.Libc.WindowsRawSocket(0x0000000000000234) open, 0 bytes waiting)", MIME type text/plain)), (:use_libgit2_for_all_downloads, ("false", MIME type text/plain)), (:use_only_tarballs_for_downloads, ("false", MIME type text/plain)), (:num_concurrent_downloads, ("8", MIME type text/plain)), (:graph_verbose, ("false", MIME type text/plain)), (:julia_version, ("v\"1.6.3\"", MIME type text/plain)), (:status_io, ("nothing", MIME type text/plain)), (:parser, (Dict{Symbol, Any}(:prefix => "Base.TOML.Parser", :elements => Any[(:str, ("\"\"", MIME type text/plain)), (:current_char, ("'\\xff\\xff\\xff\\xff': Malformed UTF-8 (category Ma: Malformed, bad data)", MIME type text/plain)), (:pos, ("1", MIME type text/plain)), (:prevpos, ("1", MIME type text/plain)), (:column, ("1", MIME type text/plain)), (:line, ("1", MIME type text/plain)), (:marker, ("0", MIME type text/plain)), (:active_table, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "d2875eee4dcfcc4e"), MIME type application/vnd.pluto.tree+object)), (:dotted_keys, (Dict{Symbol, Any}(:prefix => "String", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "2c7cea3481bae3cd"), MIME type application/vnd.pluto.tree+object)), (:chunks, (Dict{Symbol, Any}(:prefix => "UnitRange{Int64}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "cab86d94be31e5c3"), MIME type application/vnd.pluto.tree+object)), (:inline_tables, (Dict{Symbol, Any}(:prefix => "Base.IdSet{Dict{String, Any}}", :elements => Any[], :type => :Set, :prefix_short => "IdSet", :objectid => "210b5d4569f2d633"), MIME type application/vnd.pluto.tree+object)), (:static_arrays, (Dict{Symbol, Any}(:prefix => "Base.IdSet{Any}", :elements => Any[], :type => :Set, :prefix_short => "IdSet", :objectid => "16a60d70d528354e"), MIME type application/vnd.pluto.tree+object)), (:defined_tables, (Dict{Symbol, Any}(:prefix => "Base.IdSet{Dict{String, Any}}", :elements => Any[], :type => :Set, :prefix_short => "IdSet", :objectid => "9821b16b581f7c81"), MIME type application/vnd.pluto.tree+object)), (:root, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "d2875eee4dcfcc4e"), MIME type application/vnd.pluto.tree+object)), (:filepath, ("nothing", MIME type text/plain)), (:Dates, ("Dates", MIME type text/plain))], :type => :struct, :prefix_short => "Parser", :objectid => "4129e0562bd66fc4"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Context", :objectid => "5424b9cc510a8a78"), MIME type application/vnd.pluto.tree+object)), (:nbpkg_ctx_instantiated, ("false", MIME type text/plain)), (:nbpkg_restart_recommended_msg, ("nothing", MIME type text/plain)), (:nbpkg_restart_required_msg, ("nothing", MIME type text/plain)), (:nbpkg_terminal_outputs, (Dict{Symbol, Any}(:prefix => "Dict{String, String}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "b5f985e794b42399"), MIME type application/vnd.pluto.tree+object)), (:nbpkg_busy_packages, (Dict{Symbol, Any}(:prefix => "String", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "e82a5f40f915d343"), MIME type application/vnd.pluto.tree+object)), (:nbpkg_installed_versions_cache, (Dict{Symbol, Any}(:prefix => "Dict{String, String}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "8d6a72524395f573"), MIME type application/vnd.pluto.tree+object)), (:process_status, ("\"starting\"", MIME type text/plain)), (:wants_to_interrupt, ("false", MIME type text/plain)), (:last_save_time, ("1.639213270753e9", MIME type text/plain)), (:last_hot_reload_time, ("0.0", MIME type text/plain)), (:bonds, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Pluto.BondValue}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "8f6b1a03c797470e"), MIME type application/vnd.pluto.tree+object))], :struct, "Notebook", "de530ede65d3c84e"]
```

```
nb=executecode(notebook)
------
Output
------
Any["Notebook", Any[(:cells_dict, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Pluto.Cell}", :elements => Any[(("UUID(\"e29f8c70-5a60-11ec-1d98-6b0d3a1c0507\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-1d98-6b0d3a1c0507\")", MIME type text/plain)), (:code, ("\"f(4)\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"5\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "710d6f0d2be041e1"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "3eb52c61f45dd923"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x00000000000020d0", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "188c736151cd8e07"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "ede415497c7cd020"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "f4b7b049ea428e50"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "34b479eb216a9aa"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"e29f8c70-5a60-11ec-24f6-97c93ef6164d\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-24f6-97c93ef6164d\")", MIME type text/plain)), (:code, ("\"x = 1\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":x", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "c88b057388e7d241"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "9530de33cc2d0952"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000000012c", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "aaf34a3a769b377b"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "5e0962e75cc75d5a"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "209a4ede02242234"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "3bfbdf43a377e46b"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"e29f8c70-5a60-11ec-19d8-914389ca9ff1\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-19d8-914389ca9ff1\")", MIME type text/plain)), (:code, ("\"y = x\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":y", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "fecb4ba7e258d44f"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "c71efe690c103933"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000000012c", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "ce61bcbe3d785a42"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "3537200e8b2322ad"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "9014ba2caa414d56"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "42cf3454311e8c80"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"e29f8c70-5a60-11ec-0bb1-ebbe763dde2e\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-0bb1-ebbe763dde2e\")", MIME type text/plain)), (:code, ("\"Distributed.myid()\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"6\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "1a8e78419442c8bd"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "bfb0452976296910"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000499b5c", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "2a52a35cf55a167a"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "33fca04908ae1012"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "1bef42964b4656d7"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "7db20e7526e42b11"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"e29f8c70-5a60-11ec-2e8e-330a12d1c56f\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-2e8e-330a12d1c56f\")", MIME type text/plain)), (:code, ("\"begin\\n    g(a) = x\\n    g(a,b) = y      \\nend\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"g (generic function with 2 methods)\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "4bd98fc9ee9fb8ca"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "9f96157eb6133163"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000000b4dc", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "13bf3d25c8333550"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "37b7d93b9021737b"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "bb04a99c0e720946"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "dd262e48e5cc7637"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"e29f8c70-5a60-11ec-2a1d-19bc9b238325\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-2a1d-19bc9b238325\")", MIME type text/plain)), (:code, ("\"g(6) + g(6,6)\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"2\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "20c1d6558964d93c"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "b2933caf5c0496d8"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x00000000000019c8", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "5b2c5b78d70a63bd"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "4ec10c153e33c892"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "a502722d69992703"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "e866b00afc4d779f"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"e29f8c70-5a60-11ec-2337-2d3c936c9f83\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-2337-2d3c936c9f83\")", MIME type text/plain)), (:code, ("\"f(x) = x + y\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"f (generic function with 1 method)\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "d849ca91514181a1"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "144c6a5a2610ace8"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000009538", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "48a025db31f1efb6"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "c07b6a0aa1a8bedb"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "f85b2404141536b7"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "2ebe6c2588fcfa07"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"e29f8c70-5a60-11ec-127a-4580729df82c\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-127a-4580729df82c\")", MIME type text/plain)), (:code, ("\"import Distributed\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "37ca523066122baf"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "1132ab9099493821"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000cf8adc", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "33543389875a4a77"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "e7e15c70f07490eb"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "e8d7ce562e389abb"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "d04e0d55cc1c2ae9"), MIME type application/vnd.pluto.tree+object))], :type => :Dict, :prefix_short => "Dict", :objectid => "6f5c153988e4698a"), MIME type application/vnd.pluto.tree+object)), (:cell_order, (Dict{Symbol, Any}(:prefix => "Base.UUID", :elements => Tuple{Int64, Any}[(1, ("UUID(\"e29f8c70-5a60-11ec-24f6-97c93ef6164d\")", MIME type text/plain)), (2, ("UUID(\"e29f8c70-5a60-11ec-19d8-914389ca9ff1\")", MIME type text/plain)), (3, ("UUID(\"e29f8c70-5a60-11ec-2337-2d3c936c9f83\")", MIME type text/plain)), (4, ("UUID(\"e29f8c70-5a60-11ec-1d98-6b0d3a1c0507\")", MIME type text/plain)), (5, ("UUID(\"e29f8c70-5a60-11ec-2e8e-330a12d1c56f\")", MIME type text/plain)), (6, ("UUID(\"e29f8c70-5a60-11ec-2a1d-19bc9b238325\")", MIME type text/plain)), (7, ("UUID(\"e29f8c70-5a60-11ec-127a-4580729df82c\")", MIME type text/plain)), (8, ("UUID(\"e29f8c70-5a60-11ec-0bb1-ebbe763dde2e\")", MIME type text/plain))], :type => :Array, :prefix_short => "", :objectid => "157043a5d5e29174"), MIME type application/vnd.pluto.tree+object)), (:path, ("\"C:\\\\Users\\\\family\\\\.julia\\\\pluto_notebooks\\\\Cute analysis.jl\"", MIME type text/plain)), (:notebook_id, ("UUID(\"e29f8c70-5a60-11ec-134e-09f21a771bdf\")", MIME type text/plain)), (:topology, (Dict{Symbol, Any}(:prefix => "Pluto.NotebookTopology", :elements => Any[(:nodes, (Dict{Symbol, Any}(:prefix => "Pluto.DefaultDict{Pluto.Cell, Pluto.ReactiveNode}", :elements => Any[((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-19d8-914389ca9ff1\")", MIME type text/plain)), (:code, ("\"y = x\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":y", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "fecb4ba7e258d44f"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "c71efe690c103933"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000000012c", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "ce61bcbe3d785a42"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "3537200e8b2322ad"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "9014ba2caa414d56"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "42cf3454311e8c80"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ReactiveNode", :elements => Any[(:references, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "1857cb38a2476fa7"), MIME type application/vnd.pluto.tree+object)), (:definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "185e80cec1eb55d0"), MIME type application/vnd.pluto.tree+object)), (:soft_definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "5a06ce22ce7e3ba6"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_with_signatures, (Dict{Symbol, Any}(:prefix => "Set{Pluto.ExpressionExplorer.FunctionNameSignaturePair}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "9f3067ea9ef316e3"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_without_signatures, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "d77df87c868d0773"), MIME type application/vnd.pluto.tree+object)), (:macrocalls, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "4942f2b21d1a97f0"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "ReactiveNode", :objectid => "8b5ddce1c1f15e6f"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-1d98-6b0d3a1c0507\")", MIME type text/plain)), (:code, ("\"f(4)\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"5\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "710d6f0d2be041e1"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "3eb52c61f45dd923"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x00000000000020d0", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "188c736151cd8e07"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "ede415497c7cd020"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "f4b7b049ea428e50"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "34b479eb216a9aa"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ReactiveNode", :elements => Any[(:references, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "f4846905c417afa5"), MIME type application/vnd.pluto.tree+object)), (:definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "1d1752c5c33343a4"), MIME type application/vnd.pluto.tree+object)), (:soft_definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "ccf47ad794e2f9aa"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_with_signatures, (Dict{Symbol, Any}(:prefix => "Set{Pluto.ExpressionExplorer.FunctionNameSignaturePair}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "f4eed6deee4711ee"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_without_signatures, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "aa51b873af7376a1"), MIME type application/vnd.pluto.tree+object)), (:macrocalls, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "8b28ba03292301db"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "ReactiveNode", :objectid => "8f1dc4b401ce4bf"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-24f6-97c93ef6164d\")", MIME type text/plain)), (:code, ("\"x = 1\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":x", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "c88b057388e7d241"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "9530de33cc2d0952"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000000012c", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "aaf34a3a769b377b"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "5e0962e75cc75d5a"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "209a4ede02242234"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "3bfbdf43a377e46b"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ReactiveNode", :elements => Any[(:references, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "88c5430f549591a3"), MIME type application/vnd.pluto.tree+object)), (:definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "fe125cc8f555f601"), MIME type application/vnd.pluto.tree+object)), (:soft_definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "144e64ccdfae50fd"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_with_signatures, (Dict{Symbol, Any}(:prefix => "Set{Pluto.ExpressionExplorer.FunctionNameSignaturePair}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "84f517c796f4bd35"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_without_signatures, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "5ec1059c7f8c5e17"), MIME type application/vnd.pluto.tree+object)), (:macrocalls, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "ac05a757084584b0"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "ReactiveNode", :objectid => "c2e471fba5c36712"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-127a-4580729df82c\")", MIME type text/plain)), (:code, ("\"import Distributed\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "37ca523066122baf"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "1132ab9099493821"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000cf8adc", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "33543389875a4a77"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "e7e15c70f07490eb"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "e8d7ce562e389abb"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "d04e0d55cc1c2ae9"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ReactiveNode", :elements => Any[(:references, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "30e04fead1b9798b"), MIME type application/vnd.pluto.tree+object)), (:definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "782e9bea54d20676"), MIME type application/vnd.pluto.tree+object)), (:soft_definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "b41061414bb1d7f2"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_with_signatures, (Dict{Symbol, Any}(:prefix => "Set{Pluto.ExpressionExplorer.FunctionNameSignaturePair}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "4175726ee5e175aa"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_without_signatures, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "2db84c335d0987d5"), MIME type application/vnd.pluto.tree+object)), (:macrocalls, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "fa275c6eb2592ba"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "ReactiveNode", :objectid => "b6ba7e06b66e9359"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-0bb1-ebbe763dde2e\")", MIME type text/plain)), (:code, ("\"Distributed.myid()\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"6\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "1a8e78419442c8bd"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "bfb0452976296910"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000499b5c", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "2a52a35cf55a167a"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "33fca04908ae1012"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "1bef42964b4656d7"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "7db20e7526e42b11"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ReactiveNode", :elements => Any[(:references, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "d7ff2f055e9f6e58"), MIME type application/vnd.pluto.tree+object)), (:definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "9a907e3c0826185c"), MIME type application/vnd.pluto.tree+object)), (:soft_definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "76043e93004e9be8"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_with_signatures, (Dict{Symbol, Any}(:prefix => "Set{Pluto.ExpressionExplorer.FunctionNameSignaturePair}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "5d4b795eaae18dc3"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_without_signatures, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "ffbeeee52e58ec34"), MIME type application/vnd.pluto.tree+object)), (:macrocalls, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "270b1ff08637ff85"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "ReactiveNode", :objectid => "5546df6d5a5f628"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-2337-2d3c936c9f83\")", MIME type text/plain)), (:code, ("\"f(x) = x + y\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"f (generic function with 1 method)\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "d849ca91514181a1"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "144c6a5a2610ace8"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000009538", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "48a025db31f1efb6"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "c07b6a0aa1a8bedb"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "f85b2404141536b7"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "2ebe6c2588fcfa07"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ReactiveNode", :elements => Any[(:references, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "cb4d9dced4ed0719"), MIME type application/vnd.pluto.tree+object)), (:definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "71d97392bff96da6"), MIME type application/vnd.pluto.tree+object)), (:soft_definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "68d33c14e629d7e3"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_with_signatures, (Dict{Symbol, Any}(:prefix => "Set{Pluto.ExpressionExplorer.FunctionNameSignaturePair}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "730b713a1cd83a7a"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_without_signatures, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "33d324887f4a2e60"), MIME type application/vnd.pluto.tree+object)), (:macrocalls, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "17930764d7bef108"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "ReactiveNode", :objectid => "fea30163071440ed"), MIME type application/vnd.pluto.tree+object)), "more"], :type => :Dict, :prefix_short => "DefaultDict", :objectid => "8030e23213eb5feb"), MIME type application/vnd.pluto.tree+object)), (:codes, (Dict{Symbol, Any}(:prefix => "Pluto.DefaultDict{Pluto.Cell, Pluto.ExprAnalysisCache}", :elements => Any[((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-19d8-914389ca9ff1\")", MIME type text/plain)), (:code, ("\"y = x\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":y", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "fecb4ba7e258d44f"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "c71efe690c103933"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000000012c", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "ce61bcbe3d785a42"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "3537200e8b2322ad"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "9014ba2caa414d56"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "42cf3454311e8c80"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ExprAnalysisCache", :elements => Any[(:code, ("\"y = x\"", MIME type text/plain)), (:parsedcode, (":(\$(Expr(:toplevel, :(#= C:\\Users\\family\\.julia\\pluto_notebooks\\Cute analysis.jl#==#e29f8c70-5a60-11ec-19d8-914389ca9ff1:1 =#), :(y = x))))", MIME type text/plain)), (:module_usings_imports, (Dict{Symbol, Any}(:prefix => "UsingsImports", :elements => Any[(:usings, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "b5991d52df05b84f"), MIME type application/vnd.pluto.tree+object)), (:imports, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "9ae95e821ddb40ec"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "UsingsImports", :objectid => "f17c9c26629f6219"), MIME type application/vnd.pluto.tree+object)), (:function_wrapped, ("true", MIME type text/plain))], :type => :struct, :prefix_short => "ExprAnalysisCache", :objectid => "8abac0fe3fdf19a4"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-1d98-6b0d3a1c0507\")", MIME type text/plain)), (:code, ("\"f(4)\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"5\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "710d6f0d2be041e1"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "3eb52c61f45dd923"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x00000000000020d0", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "188c736151cd8e07"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "ede415497c7cd020"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "f4b7b049ea428e50"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "34b479eb216a9aa"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ExprAnalysisCache", :elements => Any[(:code, ("\"f(4)\"", MIME type text/plain)), (:parsedcode, (":(\$(Expr(:toplevel, :(#= C:\\Users\\family\\.julia\\pluto_notebooks\\Cute analysis.jl#==#e29f8c70-5a60-11ec-1d98-6b0d3a1c0507:1 =#), :(f(4)))))", MIME type text/plain)), (:module_usings_imports, (Dict{Symbol, Any}(:prefix => "UsingsImports", :elements => Any[(:usings, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "8aa31b12d1d0bc4c"), MIME type application/vnd.pluto.tree+object)), (:imports, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "190792b84916e114"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "UsingsImports", :objectid => "823f05fea849a83b"), MIME type application/vnd.pluto.tree+object)), (:function_wrapped, ("true", MIME type text/plain))], :type => :struct, :prefix_short => "ExprAnalysisCache", :objectid => "4bb09a4471d361c8"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-24f6-97c93ef6164d\")", MIME type text/plain)), (:code, ("\"x = 1\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":x", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "c88b057388e7d241"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "9530de33cc2d0952"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000000012c", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "aaf34a3a769b377b"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "5e0962e75cc75d5a"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "209a4ede02242234"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "3bfbdf43a377e46b"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ExprAnalysisCache", :elements => Any[(:code, ("\"x = 1\"", MIME type text/plain)), (:parsedcode, (":(\$(Expr(:toplevel, :(#= C:\\Users\\family\\.julia\\pluto_notebooks\\Cute analysis.jl#==#e29f8c70-5a60-11ec-24f6-97c93ef6164d:1 =#), :(x = 1))))", MIME type text/plain)), (:module_usings_imports, (Dict{Symbol, Any}(:prefix => "UsingsImports", :elements => Any[(:usings, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "322d6e8e6629c033"), MIME type application/vnd.pluto.tree+object)), (:imports, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "cf36b50d962d63cf"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "UsingsImports", :objectid => "a3fccd12f0fce9c3"), MIME type application/vnd.pluto.tree+object)), (:function_wrapped, ("true", MIME type text/plain))], :type => :struct, :prefix_short => "ExprAnalysisCache", :objectid => "9718cbbcfe5c15e5"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-127a-4580729df82c\")", MIME type text/plain)), (:code, ("\"import Distributed\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "37ca523066122baf"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "1132ab9099493821"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000cf8adc", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "33543389875a4a77"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "e7e15c70f07490eb"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "e8d7ce562e389abb"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "d04e0d55cc1c2ae9"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ExprAnalysisCache", :elements => Any[(:code, ("\"import Distributed\"", MIME type text/plain)), (:parsedcode, (":(\$(Expr(:toplevel, :(#= C:\\Users\\family\\.julia\\pluto_notebooks\\Cute analysis.jl#==#e29f8c70-5a60-11ec-127a-4580729df82c:1 =#), :(import Distributed))))", MIME type text/plain)), (:module_usings_imports, (Dict{Symbol, Any}(:prefix => "UsingsImports", :elements => Any[(:usings, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "6000af5aab4c591e"), MIME type application/vnd.pluto.tree+object)), (:imports, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "a086afc8fb26dcde"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "UsingsImports", :objectid => "b7085c920f0511cc"), MIME type application/vnd.pluto.tree+object)), (:function_wrapped, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "ExprAnalysisCache", :objectid => "7d0fc584e203c8ff"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-0bb1-ebbe763dde2e\")", MIME type text/plain)), (:code, ("\"Distributed.myid()\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"6\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "1a8e78419442c8bd"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "bfb0452976296910"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000499b5c", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "2a52a35cf55a167a"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "33fca04908ae1012"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "1bef42964b4656d7"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "7db20e7526e42b11"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ExprAnalysisCache", :elements => Any[(:code, ("\"Distributed.myid()\"", MIME type text/plain)), (:parsedcode, (":(\$(Expr(:toplevel, :(#= C:\\Users\\family\\.julia\\pluto_notebooks\\Cute analysis.jl#==#e29f8c70-5a60-11ec-0bb1-ebbe763dde2e:1 =#), :(Distributed.myid()))))", MIME type text/plain)), (:module_usings_imports, (Dict{Symbol, Any}(:prefix => "UsingsImports", :elements => Any[(:usings, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "2e2af7e16f1ed9f1"), MIME type application/vnd.pluto.tree+object)), (:imports, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "9abbc8e35208429d"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "UsingsImports", :objectid => "87a444952838510f"), MIME type application/vnd.pluto.tree+object)), (:function_wrapped, ("true", MIME type text/plain))], :type => :struct, :prefix_short => "ExprAnalysisCache", :objectid => "ef461c048d947e1d"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-2337-2d3c936c9f83\")", MIME type text/plain)), (:code, ("\"f(x) = x + y\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"f (generic function with 1 method)\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "d849ca91514181a1"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "144c6a5a2610ace8"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000009538", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "48a025db31f1efb6"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "c07b6a0aa1a8bedb"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "f85b2404141536b7"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "2ebe6c2588fcfa07"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ExprAnalysisCache", :elements => Any[(:code, ("\"f(x) = x + y\"", MIME type text/plain)), (:parsedcode, (":(\$(Expr(:toplevel, :(#= C:\\Users\\family\\.julia\\pluto_notebooks\\Cute analysis.jl#==#e29f8c70-5a60-11ec-2337-2d3c936c9f83:1 =#), :(f(x) = begin\n          #= C:\\Users\\family\\.julia\\pluto_notebooks\\Cute analysis.jl#==#e29f8c70-5a60-11ec-2337-2d3c936c9f83:1 =#\n          x + y\n      end))))", MIME type text/plain)), (:module_usings_imports, (Dict{Symbol, Any}(:prefix => "UsingsImports", :elements => Any[(:usings, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "b024b12b0e568706"), MIME type application/vnd.pluto.tree+object)), (:imports, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "6e92d6d37d42c929"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "UsingsImports", :objectid => "4dc60d0e9b9b2568"), MIME type application/vnd.pluto.tree+object)), (:function_wrapped, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "ExprAnalysisCache", :objectid => "865215c9c50b07f1"), MIME type application/vnd.pluto.tree+object)), "more"], :type => :Dict, :prefix_short => "DefaultDict", :objectid => "99b6b7c60c16889c"), MIME type application/vnd.pluto.tree+object)), (:unresolved_cells, (Dict{Symbol, Any}(:prefix => "Dict{Pluto.Cell, Pluto.ExpressionExplorer.SymbolsState}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "de4f1d50e1797d33"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "NotebookTopology", :objectid => "18c1d7a2dc3a2005"), MIME type application/vnd.pluto.tree+object)), (:_cached_topological_order, (Dict{Symbol, Any}(:prefix => "Pluto.TopologicalOrder", :elements => Any[(:input_topology, (Dict{Symbol, Any}(:prefix => "Pluto.NotebookTopology", :elements => Any[(:nodes, (Dict{Symbol, Any}(:prefix => "Pluto.DefaultDict{Pluto.Cell, Pluto.ReactiveNode}", :elements => Any["more"], :type => :Dict, :prefix_short => "DefaultDict", :objectid => "8030e23213eb5feb"), MIME type application/vnd.pluto.tree+object)), (:codes, (Dict{Symbol, Any}(:prefix => "Pluto.DefaultDict{Pluto.Cell, Pluto.ExprAnalysisCache}", :elements => Any["more"], :type => :Dict, :prefix_short => "DefaultDict", :objectid => "99b6b7c60c16889c"), MIME type application/vnd.pluto.tree+object)), (:unresolved_cells, (Dict{Symbol, Any}(:prefix => "Dict{Pluto.Cell, Pluto.ExpressionExplorer.SymbolsState}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "de4f1d50e1797d33"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "NotebookTopology", :objectid => "18c1d7a2dc3a2005"), MIME type application/vnd.pluto.tree+object)), (:runnable, (Dict{Symbol, Any}(:prefix => "Pluto.Cell", :elements => Any[(1, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-24f6-97c93ef6164d\")", MIME type text/plain)), (:code, ("\"x = 1\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":x", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "c88b057388e7d241"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "9530de33cc2d0952"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000000012c", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "aaf34a3a769b377b"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "5e0962e75cc75d5a"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "209a4ede02242234"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "3bfbdf43a377e46b"), MIME type application/vnd.pluto.tree+object)), (2, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-19d8-914389ca9ff1\")", MIME type text/plain)), (:code, ("\"y = x\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":y", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "fecb4ba7e258d44f"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "c71efe690c103933"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000000012c", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "ce61bcbe3d785a42"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "3537200e8b2322ad"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "9014ba2caa414d56"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "42cf3454311e8c80"), MIME type application/vnd.pluto.tree+object)), (3, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-2337-2d3c936c9f83\")", MIME type text/plain)), (:code, ("\"f(x) = x + y\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"f (generic function with 1 method)\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "d849ca91514181a1"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "144c6a5a2610ace8"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000009538", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "48a025db31f1efb6"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "c07b6a0aa1a8bedb"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "f85b2404141536b7"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "2ebe6c2588fcfa07"), MIME type application/vnd.pluto.tree+object)), (4, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-1d98-6b0d3a1c0507\")", MIME type text/plain)), (:code, ("\"f(4)\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"5\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "710d6f0d2be041e1"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "3eb52c61f45dd923"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x00000000000020d0", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "188c736151cd8e07"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "ede415497c7cd020"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "f4b7b049ea428e50"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "34b479eb216a9aa"), MIME type application/vnd.pluto.tree+object)), (5, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-2e8e-330a12d1c56f\")", MIME type text/plain)), (:code, ("\"begin\\n    g(a) = x\\n    g(a,b) = y      \\nend\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"g (generic function with 2 methods)\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "4bd98fc9ee9fb8ca"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "9f96157eb6133163"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000000b4dc", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "13bf3d25c8333550"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "37b7d93b9021737b"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "bb04a99c0e720946"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "dd262e48e5cc7637"), MIME type application/vnd.pluto.tree+object)), "more", (8, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"e29f8c70-5a60-11ec-0bb1-ebbe763dde2e\")", MIME type text/plain)), (:code, ("\"Distributed.myid()\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"6\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.63921e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "1a8e78419442c8bd"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "bfb0452976296910"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000499b5c", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "2a52a35cf55a167a"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "33fca04908ae1012"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain)), (:contains_user_defined_macrocalls, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "1bef42964b4656d7"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "7db20e7526e42b11"), MIME type application/vnd.pluto.tree+object))], :type => :Array, :prefix_short => "", :objectid => "8338699b14c4078"), MIME type application/vnd.pluto.tree+object)), (:errable, (Dict{Symbol, Any}(:prefix => "Dict{Pluto.Cell, Pluto.ReactivityError}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "eae4d1f7faa4dffd"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "TopologicalOrder", :objectid => "a66fe53e72043643"), MIME type application/vnd.pluto.tree+object)), (:pendingupdates, ("Channel{Any}(1024) (empty)", MIME type text/plain)), (:executetoken, (Dict{Symbol, Any}(:prefix => "Pluto.Token", :elements => Any[(:c, ("Channel{Nothing}(1) (1 item available)", MIME type text/plain))], :type => :struct, :prefix_short => "Token", :objectid => "f4b69849ad38f404"), MIME type application/vnd.pluto.tree+object)), (:compiler_options, ("nothing", MIME type text/plain)), (:nbpkg_ctx, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Context", :elements => Any[(:env, (Dict{Symbol, Any}(:prefix => "Pkg.Types.EnvCache", :elements => Any[(:env, ("\"C:\\\\Users\\\\family\\\\AppData\\\\Local\\\\Temp\\\\jl_eoJRD6\\\\Project.toml\"", MIME type text/plain)), (:project_file, ("\"C:\\\\Users\\\\family\\\\AppData\\\\Local\\\\Temp\\\\jl_eoJRD6\\\\Project.toml\"", MIME type text/plain)), (:manifest_file, ("\"C:\\\\Users\\\\family\\\\AppData\\\\Local\\\\Temp\\\\jl_eoJRD6\\\\Manifest.toml\"", MIME type text/plain)), (:pkg, ("nothing", MIME type text/plain)), (:project, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Project", :elements => Any[(:other, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "356b65e88e65b605"), MIME type application/vnd.pluto.tree+object)), (:name, ("nothing", MIME type text/plain)), (:uuid, ("nothing", MIME type text/plain)), (:version, ("nothing", MIME type text/plain)), (:manifest, ("nothing", MIME type text/plain)), (:deps, (Dict{Symbol, Any}(:prefix => "Dict{String, Base.UUID}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "ffa07488a2cf9586"), MIME type application/vnd.pluto.tree+object)), (:extras, (Dict{Symbol, Any}(:prefix => "Dict{String, Base.UUID}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "1e03c4fa5f963821"), MIME type application/vnd.pluto.tree+object)), (:targets, (Dict{Symbol, Any}(:prefix => "Dict{String, Vector{String}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "7980acde968fff98"), MIME type application/vnd.pluto.tree+object)), (:compat, (Dict{Symbol, Any}(:prefix => "Dict{String, String}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "61984aece6bf3d8d"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Project", :objectid => "61c311f461f54650"), MIME type application/vnd.pluto.tree+object)), (:manifest, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Manifest", :elements => Any[(:julia_version, ("nothing", MIME type text/plain)), (:manifest_format, ("v\"1.0.0\"", MIME type text/plain)), (:deps, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Pkg.Types.PackageEntry}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "6e8894e780841686"), MIME type application/vnd.pluto.tree+object)), (:other, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "a912f94275b1761b"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Manifest", :objectid => "1efe611bd95c579c"), MIME type application/vnd.pluto.tree+object)), (:original_project, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Project", :elements => Any[(:other, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "36124a9c8d5eebdd"), MIME type application/vnd.pluto.tree+object)), (:name, ("nothing", MIME type text/plain)), (:uuid, ("nothing", MIME type text/plain)), (:version, ("nothing", MIME type text/plain)), (:manifest, ("nothing", MIME type text/plain)), (:deps, (Dict{Symbol, Any}(:prefix => "Dict{String, Base.UUID}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "604a75c061cf3f44"), MIME type application/vnd.pluto.tree+object)), (:extras, (Dict{Symbol, Any}(:prefix => "Dict{String, Base.UUID}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "ae2aa5e17d8f9de1"), MIME type application/vnd.pluto.tree+object)), (:targets, (Dict{Symbol, Any}(:prefix => "Dict{String, Vector{String}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "d04fd2acc1d9f6e7"), MIME type application/vnd.pluto.tree+object)), (:compat, (Dict{Symbol, Any}(:prefix => "Dict{String, String}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "a67bfb826e324403"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Project", :objectid => "22c72e91422a7562"), MIME type application/vnd.pluto.tree+object)), (:original_manifest, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Manifest", :elements => Any[(:julia_version, ("nothing", MIME type text/plain)), (:manifest_format, ("v\"1.0.0\"", MIME type text/plain)), (:deps, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Pkg.Types.PackageEntry}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "6cbc59e8fab2ff9d"), MIME type application/vnd.pluto.tree+object)), (:other, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "977d50645034e9b3"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Manifest", :objectid => "a6a8a27dcd6dc789"), MIME type application/vnd.pluto.tree+object)), (:uuids, (Dict{Symbol, Any}(:prefix => "Dict{String, Vector{Base.UUID}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "9f29d4f361dede0d"), MIME type application/vnd.pluto.tree+object)), (:paths, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Vector{String}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "ea6ad2337860e938"), MIME type application/vnd.pluto.tree+object)), (:names, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Vector{String}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "50cdb7064526afd8"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "EnvCache", :objectid => "ac630c9a77319327"), MIME type application/vnd.pluto.tree+object)), (:io, ("Base.PipeEndpoint(Base.Libc.WindowsRawSocket(0x0000000000000234) open, 0 bytes waiting)", MIME type text/plain)), (:use_libgit2_for_all_downloads, ("false", MIME type text/plain)), (:use_only_tarballs_for_downloads, ("false", MIME type text/plain)), (:num_concurrent_downloads, ("8", MIME type text/plain)), (:graph_verbose, ("false", MIME type text/plain)), (:julia_version, ("v\"1.6.3\"", MIME type text/plain)), (:status_io, ("nothing", MIME type text/plain)), (:parser, (Dict{Symbol, Any}(:prefix => "Base.TOML.Parser", :elements => Any[(:str, ("\"\"", MIME type text/plain)), (:current_char, ("'\\xff\\xff\\xff\\xff': Malformed UTF-8 (category Ma: Malformed, bad data)", MIME type text/plain)), (:pos, ("1", MIME type text/plain)), (:prevpos, ("1", MIME type text/plain)), (:column, ("1", MIME type text/plain)), (:line, ("1", MIME type text/plain)), (:marker, ("0", MIME type text/plain)), (:active_table, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "1df082015f6c162f"), MIME type application/vnd.pluto.tree+object)), (:dotted_keys, (Dict{Symbol, Any}(:prefix => "String", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "6f14104981b32e6e"), MIME type application/vnd.pluto.tree+object)), (:chunks, (Dict{Symbol, Any}(:prefix => "UnitRange{Int64}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "f1d8f418073cf301"), MIME type application/vnd.pluto.tree+object)), (:inline_tables, (Dict{Symbol, Any}(:prefix => "Base.IdSet{Dict{String, Any}}", :elements => Any[], :type => :Set, :prefix_short => "IdSet", :objectid => "572ae43fd381efbf"), MIME type application/vnd.pluto.tree+object)), (:static_arrays, (Dict{Symbol, Any}(:prefix => "Base.IdSet{Any}", :elements => Any[], :type => :Set, :prefix_short => "IdSet", :objectid => "6f48687003bcf7c7"), MIME type application/vnd.pluto.tree+object)), (:defined_tables, (Dict{Symbol, Any}(:prefix => "Base.IdSet{Dict{String, Any}}", :elements => Any[], :type => :Set, :prefix_short => "IdSet", :objectid => "a37663e06c18ed0f"), MIME type application/vnd.pluto.tree+object)), (:root, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "1df082015f6c162f"), MIME type application/vnd.pluto.tree+object)), (:filepath, ("nothing", MIME type text/plain)), (:Dates, ("Dates", MIME type text/plain))], :type => :struct, :prefix_short => "Parser", :objectid => "b1bf13f60c37a076"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Context", :objectid => "6229cf06e7dea9dd"), MIME type application/vnd.pluto.tree+object)), (:nbpkg_ctx_instantiated, ("true", MIME type text/plain)), (:nbpkg_restart_recommended_msg, ("nothing", MIME type text/plain)), (:nbpkg_restart_required_msg, ("nothing", MIME type text/plain)), (:nbpkg_terminal_outputs, (Dict{Symbol, Any}(:prefix => "Dict{String, String}", :elements => Any[(("\"Distributed\"", MIME type text/plain), ("\"\\e[32m\\e[1m  No Changes\\e[22m\\e[39m to `C:\\\\Users\\\\family\\\\AppData\\\\Local\\\\Temp\\\\jl_eoJRD6\\\\Project.toml`\\n\\e[32m\\e[1m  No Changes\\e[22m\\e[39m to `C:\\\\Users\\\\family\\\\AppData\\\\Local\\\\Temp\\\\jl_eoJRD6\\\\Manifest.toml`\\n\\e[32m\\e[1mLoading\\e[22m\\e[39m packages...\\n\"", MIME type text/plain))], :type => :Dict, :prefix_short => "Dict", :objectid => "b5f985e794b42399"), MIME type application/vnd.pluto.tree+object)), (:nbpkg_busy_packages, (Dict{Symbol, Any}(:prefix => "String", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "c3fc96cb8c1a4068"), MIME type application/vnd.pluto.tree+object)), (:nbpkg_installed_versions_cache, (Dict{Symbol, Any}(:prefix => "Dict{String, String}", :elements => Any[(("\"Distributed\"", MIME type text/plain), ("\"stdlib\"", MIME type text/plain))], :type => :Dict, :prefix_short => "Dict", :objectid => "8d1df3909e5d07d7"), MIME type application/vnd.pluto.tree+object)), (:process_status, ("\"ready\"", MIME type text/plain)), (:wants_to_interrupt, ("false", MIME type text/plain)), (:last_save_time, ("1.639213270753e9", MIME type text/plain)), (:last_hot_reload_time, ("0.0", MIME type text/plain)), (:bonds, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Pluto.BondValue}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "8f6b1a03c797470e"), MIME type application/vnd.pluto.tree+object))], :struct, "Notebook", "de530ede65d3c84e"]
```

```
#noop
@test nb.cells[4].output.body == "5"
------
Output
------
 
```

> executecode(nb::Notebook)–> This function does the following
>
>   * Take a notebook.
>   * Create a fake server, fake client etc.
>   * Run the notebook cell by cell and update the notebook with the output.




